VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private strBit As String
Private strNom As String
Private intPosicio As Integer
Private intEstat As Integer

Public Function Inicialitza(strCadena As String) As Boolean
Dim varP As Variant

   On Error GoTo TractaError
   
   'Miro si tinc alguna coma a la cadena que em passen
   If InStr(1, strCadena, ",") > 1 Then
      'Passo la cadena a una matriu
      varP = Split(strCadena, ",")
      'Miro si la matriu es valida
      If UBound(varP) = 2 Then
         'Capturo les dades del parametre
         strBit = varP(0)              'Nom = nom de la variable bit
         strNom = varP(1)              'Nom = nom de la variable per pantalla
         intPosicio = CInt(varP(2))    'Posicio = posicio del bit dintre la variable Config
         intEstat = 0
         'Retorno true
         Inicialitza = True
      End If
   End If
         
Exit Function
TractaError:
   Inicialitza = False
End Function

Public Property Get Bit() As String
   'Retorno el nom de la variable bit
   Bit = strBit
End Property

Public Property Get Nom() As String
   'Retorno el nom de la variable per pantalla
   Nom = strNom
End Property

Public Property Get Posicio() As Integer
   'Retorno la posicio del bit dintre de la variable Config
   Posicio = intPosicio
End Property

Public Property Get Estat() As Integer
   'Retorno l'estat del bit
   Estat = intEstat
End Property

Public Property Let Estat(v As Integer)
   'Assigno l'estat del bit
   intEstat = v
End Property

Public Property Get Valor() As String
Dim strTemp As String
Dim varEstats As Variant

   On Error GoTo TractaError
   'Consulto el fitxer de configuracio per veure si l'estat del bit esta definit
   strTemp = INI_Get(strBit, "", "BITS", strFitxerConfig)
   'Miro si esta definit
   If strTemp <> "" Then
      'Passo la cadena a una matriu
      varEstats = Split(strTemp, ",")
      'Retorno la descripcio que correspongui en funcio de l'estat actual del bit
      Valor = CStr(varEstats(intEstat))
   Else
      'Retorno la descripcio que correspongui en funcio de l'estat actual del bit
      Valor = IIf(intEstat = BIT_ON, "ON", "OFF")
   End If
   
Exit Property
TractaError:
   Valor = ""
End Property

Public Function SetValor(strValor As String) As Boolean
Dim dblValor As Double

   On Error GoTo TractaError
   'Si el valor que em passen es valid
   If strValor <> "" Then
      'Passo la cadena a un numero
      dblValor = CDbl(strValor)
      'Capturo l'estat del bit a la paraula que em passen
      intEstat = IIf(BitEstatGet(dblValor, intPosicio) = BIT_ON, BIT_ON, BIT_OFF)
      'Retorno true
      SetValor = True
   End If
   
Exit Function
TractaError:
   SetValor = False
End Function

