VERSION 5.00
Begin VB.UserControl ctlElement 
   ClientHeight    =   2520
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2055
   ScaleHeight     =   2520
   ScaleWidth      =   2055
   Begin VB.CommandButton cmdBoto 
      Caption         =   "cmdBoto"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   1920
      Width           =   1815
   End
   Begin VB.PictureBox pctBarra 
      Height          =   375
      Left            =   120
      ScaleHeight     =   315
      ScaleWidth      =   1755
      TabIndex        =   1
      Top             =   1440
      Width           =   1815
      Begin VB.PictureBox pctValor 
         Appearance      =   0  'Flat
         BackColor       =   &H000000FF&
         BorderStyle     =   0  'None
         FillColor       =   &H000000FF&
         FillStyle       =   0  'Solid
         ForeColor       =   &H80000008&
         Height          =   375
         Left            =   0
         ScaleHeight     =   375
         ScaleWidth      =   855
         TabIndex        =   2
         Top             =   0
         Width           =   855
      End
   End
   Begin VB.TextBox txtValor 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   120
      Locked          =   -1  'True
      TabIndex        =   0
      Text            =   "0"
      Top             =   960
      Width           =   1815
   End
   Begin VB.Label lblEtiqueta 
      AutoSize        =   -1  'True
      Caption         =   "XXXX"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   540
   End
   Begin VB.Shape shpValor 
      FillColor       =   &H000000FF&
      FillStyle       =   0  'Solid
      Height          =   255
      Left            =   120
      Shape           =   2  'Oval
      Top             =   540
      Width           =   255
   End
End
Attribute VB_Name = "ctlElement"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event CanviarEstat(strVariable As String, lngNouValor As Long)
Public Event Seleccionar(strVariable As String)
Public Event Editar(strVariable As String)
Public Event ExecutarComanda(strComanda As String)

Private strVariable As String
Private strTipus As String
Private sngLeft As Single
Private sngTop As Single
Private sngWidth As Single
Private sngHeight As Single
Private lngBackcolor As Long
Private lngColorON As Long
Private lngColorOFF As Long
Private lngValorMaxim As Long
Private strFormat As String
Private strComandaBoto As String
Private WithEvents objVariable As clsVariable
Attribute objVariable.VB_VarHelpID = -1

Private Sub cmdBoto_Click()
   On Error Resume Next
   'Miro si tinc un boto
   If strTipus = "C" Then
      'Genero un event per executar comanda
      RaiseEvent ExecutarComanda(strComandaBoto)
   End If
End Sub

Private Sub objVariable_Actualitza()
   'Actualitzo el control
   RefrescarElement
End Sub

Private Sub pctBarra_Click()
   On Error Resume Next
   'Miro si tinc una variable associada
   If Not objVariable Is Nothing Then
      'Genero un event per identificar la variable a la llista
      RaiseEvent Seleccionar(strVariable)
   End If
End Sub

Private Sub pctValor_Click()
   On Error Resume Next
   'Miro si tinc una variable associada
   If Not objVariable Is Nothing Then
      'Genero un event per identificar la variable a la llista
      RaiseEvent Seleccionar(strVariable)
   End If
End Sub

Private Sub txtValor_Click()
   On Error Resume Next
   'Miro si tinc una variable associada
   If Not objVariable Is Nothing Then
      'Genero un event per identificar la variable a la llista
      RaiseEvent Seleccionar(strVariable)
   End If
End Sub

Private Sub txtValor_DblClick()
   On Error Resume Next
   'Miro si tinc una variable associada i es editable
   If Not objVariable Is Nothing And strTipus = "E" Then
      'Genero un event per identificar la variable a la llista
      RaiseEvent Editar(strVariable)
   End If
End Sub

Private Sub UserControl_Click()
   On Error Resume Next
   'Miro si tinc una variable associada
   If Not objVariable Is Nothing Then
      'Genero un event per identificar la variable a la llista
      RaiseEvent Seleccionar(strVariable)
   End If
End Sub

Private Sub UserControl_DblClick()
Dim lngV As Long
   
   On Error Resume Next
   'Miro si es tracta d'una I/O digital
   If strTipus = "D" And Not objVariable Is Nothing Then
      'Genero el nou valor
      lngV = IIf(objVariable.Valor = 0, 1, 0)
      'Genero un event per canviar l'estat de la variable
      RaiseEvent CanviarEstat(strVariable, lngV)
   End If
End Sub

Private Sub UserControl_Initialize()
   'Posiciono controls
   lblEtiqueta.Top = 0
   lblEtiqueta.Left = 0
   shpValor.Top = 0
   shpValor.Left = 0
   txtValor.Top = 0
   txtValor.Left = 0
   pctBarra.Top = 0
   pctBarra.Left = 0
   cmdBoto.Top = 0
   cmdBoto.Left = 0
   'Amago controls
   MostrarControlsElement
End Sub

Private Sub UserControl_Resize()
   'Redimensiono els controls
   RedimensionarControls
End Sub

Public Function Inicialitza(strCadena As String) As Boolean
Dim varE As Variant

   On Error GoTo TractaError

   'Miro si tinc alguna coma a la cadena que em passen
   If InStr(1, strCadena, ",") > 1 Then
      'Passo la cadena a una matriu
      varE = Split(strCadena, ",")
      'Miro si la matriu es valida
      If UBound(varE) >= 9 Then
         'Capturo les dades de l'element
         strVariable = varE(0)               'Variable = variable del PLC relacionada amb l'element
         strTipus = UCase(varE(1))           'D=I/O digital ON/OFF | A=I/O analogica | V=Barra de progres vertical | H=Barra de progres horitzontal | T=Text | E=Editable
         sngLeft = Val(varE(2))              'Posicio esquerra element sobre pantalla
         sngTop = Val(varE(3))               'Posicio top element sobre pantalla
         sngWidth = Val(varE(4))             'Width element sobre pantalla
         sngHeight = Val(varE(5))            'Height element sobre pantalla
         lngBackcolor = Val(varE(6))         'Color de fons de l'element
         lngColorON = Val(varE(7))           'Color element quan esta ON
         lngColorOFF = Val(varE(8))          'Color element quan esta OFF
         'Miro si no es un boto
         If strTipus <> "C" Then
            'Capturo el valor maxim permes per la variable
            lngValorMaxim = Val(varE(9))
         Else
            'Capturo la comanda que crida el boto
            strComandaBoto = varE(9)
         End If
         'Miro si tinc un format definit
         If UBound(varE) > 9 Then
            strFormat = varE(10)             'Permet definir un format per mostrar un text en funcio del valor de la variable
         End If
         'Miro si te una variable relacionada
         If strVariable <> "" And strTipus <> "T" Then
            'Busco la variable dintre dels parametres
            Set objVariable = frmPrincipal.BuscarVarParametres(strVariable)
         End If
         'Retorno true
         Inicialitza = True
      End If
   Else
      strVariable = ""
      strTipus = "T"
      sngLeft = 0
      sngTop = 0
      sngWidth = 1320
      sngHeight = 375
      lngColorON = &HC000&
      lngColorOFF = &HFF&
      lngValorMaxim = 0
      strComandaBoto = ""
   End If
   'Refresco la presentacio per pantalla
   RefrescarElement
         
Exit Function
TractaError:
   'Retorno false
   Inicialitza = False
End Function

Private Sub RefrescarElement()

   On Error GoTo TractaError
   'Selecciono en funcio del tipus de variable
   Select Case strTipus
      'Element I/O digital (ON/OFF)
      Case "D"
         'Dibuixo un element digital
         DibuixarElementD
      'Element I/O analogic (mostro el valor)
      Case "A"
         'Dibuixo un element analogic
         DibuixarElementA
      'Element I/O analogic (mostro barra de progres vertical)
      Case "V"
         'Dibuixo un element analogic en forma de barra vertical
         DibuixarElementV
      'Element I/O analogic (mostro barra de progres horitzontal)
      Case "H"
         'Dibuixo un element analogic en forma de barra horitzontal
         DibuixarElementH
      'Element etiqueta
      Case "T"
         'Dibuixo una etiqueta de text
         DibuixarElementT
      'Element I/O analogic editable
      Case "E"
         'Dibuixo un element analogic editable
         DibuixarElementE
      'Boto que crida un panell de dades
      Case "C"
         'Dibuixo un boto
         DibuixarElementC
   End Select
   
Exit Sub
TractaError:
   Err.Clear
End Sub

Private Sub DibuixarElementD()
   On Error Resume Next
   'Miro si tinc una variable relacionada
   If Not objVariable Is Nothing Then
      'Assigno el color en funcio del valor de la variable
      shpValor.FillColor = IIf(objVariable.Valor = 0, lngColorOFF, lngColorON)
   Else
      shpValor.FillColor = lngColorOFF
   End If
   'Mostro nomes els controls de l'element
   MostrarControlsElement
End Sub

Private Sub DibuixarElementA()
   On Error Resume Next
   'Miro si tinc una variable relacionada
   If Not objVariable Is Nothing Then
      'Valor i color del text
      txtValor.Text = FormatejarValor(objVariable.Valor)
      txtValor.ForeColor = IIf(objVariable.Valor < lngValorMaxim, lngColorOFF, lngColorON)
   Else
      txtValor.Text = "????"
      txtValor.ForeColor = lngColorOFF
   End If
   'Mostro nomes els controls de l'element
   MostrarControlsElement
End Sub

Private Sub DibuixarElementE()
   On Error Resume Next
   'Miro si tinc una variable relacionada
   If Not objVariable Is Nothing Then
      'Valor i color del text
      txtValor.Text = FormatejarValor(objVariable.Valor)
      txtValor.ForeColor = IIf(objVariable.Valor < lngValorMaxim, lngColorOFF, lngColorON)
   Else
      txtValor.Text = "????"
      txtValor.ForeColor = lngColorOFF
   End If
   'Mostro nomes els controls de l'element
   MostrarControlsElement
End Sub

Private Sub DibuixarElementC()
   On Error Resume Next
   'Miro si tinc una variable relacionada
   If strComandaBoto <> "" Then
      'Text i color del boto
      cmdBoto.Caption = strVariable
      cmdBoto.BackColor = lngColorOFF
   Else
      cmdBoto.Caption = "????"
      cmdBoto.BackColor = lngColorOFF
   End If
   'Mostro nomes els controls de l'element
   MostrarControlsElement
End Sub

Private Sub DibuixarElementV()
Dim lngValor As Long
Dim dblPercent As Double

   On Error Resume Next
   'Miro si tinc una variable relacionada
   If Not objVariable Is Nothing Then
      lngValor = objVariable.Valor
      'Calculo el percentatge
      dblPercent = lngValor / lngValorMaxim
      'Dibuixo la barra vertical
      pctValor.Left = pctBarra.Left
      pctValor.Top = sngHeight - sngHeight * dblPercent
      pctValor.Height = sngHeight * dblPercent
      pctValor.Width = sngWidth
      pctValor.BackColor = IIf(objVariable.Valor < lngValorMaxim, lngColorOFF, lngColorON)
      pctValor.Visible = True
   Else
      pctValor.Visible = False
   End If
   'Mostro nomes els controls de l'element
   MostrarControlsElement
End Sub

Private Sub DibuixarElementH()
Dim lngValor As Long
Dim dblPercent As Double

   On Error Resume Next
   'Miro si tinc una variable relacionada
   If Not objVariable Is Nothing Then
      lngValor = objVariable.Valor
      'Calculo el percentatge
      dblPercent = lngValor / lngValorMaxim
      'Dibuixo la barra horitzontal
      pctValor.Left = pctBarra.Left
      pctValor.Top = pctBarra.Top
      pctValor.Height = sngHeight
      pctValor.Width = sngWidth * dblPercent
      pctValor.BackColor = IIf(objVariable.Valor < lngValorMaxim, lngColorOFF, lngColorON)
      pctValor.Visible = True
   Else
      pctValor.Visible = False
   End If
   'Mostro nomes els controls de l'element
   MostrarControlsElement
End Sub

Private Sub DibuixarElementT()
   On Error Resume Next
   'Etiqueta
   lblEtiqueta.Caption = strVariable
   'Colors
   lblEtiqueta.BackColor = lngBackcolor
   lblEtiqueta.ForeColor = lngColorOFF
   'Mostro nomes els controls de l'element
   MostrarControlsElement
End Sub

Private Sub MostrarControlsElement()
   On Error Resume Next
   'Modifico el usercontrol
   UserControl.Width = sngWidth
   UserControl.Height = sngHeight
   UserControl.BackColor = lngBackcolor
   'Mostro/amago els controls
   lblEtiqueta.Visible = IIf(strTipus = "T", True, False)
   shpValor.Visible = IIf(strTipus = "D", True, False)
   txtValor.Visible = IIf(strTipus = "A" Or strTipus = "E", True, False)
   pctBarra.Visible = IIf(strTipus = "V" Or strTipus = "H", True, False)
   cmdBoto.Visible = IIf(strTipus = "C", True, False)
End Sub

Private Sub RedimensionarControls()
   On Error Resume Next
   'Redimensiono els controls
   lblEtiqueta.Width = sngWidth
   lblEtiqueta.Height = sngHeight
   shpValor.Width = sngWidth
   shpValor.Height = sngHeight
   txtValor.Width = sngWidth
   txtValor.Height = sngHeight
   pctBarra.Width = sngWidth
   pctBarra.Height = sngHeight
   cmdBoto.Width = sngWidth
   cmdBoto.Height = sngHeight
End Sub

Private Function FormatejarValor(dblValor As Double) As String
Dim varFormats As Variant
Dim i As Integer
Dim varParts As Variant
Dim intVal As Integer
Dim strText As String

   On Error GoTo TractaError
   'Miro si tinc un format especificat (p.ex.: 0=MAIZ|1=TRIGO|2=CEBADA|3=HARINA)
   If strFormat <> "" Then
      'Passo la cadena a matriu
      varFormats = Split(strFormat, "|")
      'Bucle per trobar el valor
      For i = LBound(varFormats) To UBound(varFormats)
         'Capturo el valor i el text associat
         varParts = Split(CStr(varFormats(i)), "=")
         intVal = Val(varParts(0))
         'Miro si el valor coincideix
         If intVal = CInt(dblValor) Then
            'Retorno el text associat
            FormatejarValor = CStr(varParts(1))
            Exit For
         End If
      Next i
   Else
      'Retorno el valor sense formatejar
      FormatejarValor = CStr(dblValor)
   End If
   
Exit Function
TractaError:
   FormatejarValor = CStr(dblValor)
End Function

Public Property Get Tipus() As String
   'Retorno el tipus de l'element
   Tipus = strTipus
End Property

Public Property Get Variable() As Object
   'Retorno la variable
   Set Variable = objVariable
End Property

Public Property Get PosX() As Single
   'Retorno la posicio Left del control
   PosX = sngLeft
End Property

Public Property Get PosY() As Single
   'Retorno la posicio Top del control
   PosY = sngTop
End Property

