VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAlarma"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private strVariable As String
Private intBit As Integer
Private strDescripcio As String
Private bolActiva As Boolean
Private WithEvents objVariable As clsVariable
Attribute objVariable.VB_VarHelpID = -1

Public Function Inicialitza(strCadena As String) As Boolean
Dim varA As Variant

   On Error GoTo TractaError
   'Miro si tinc alguna coma a la cadena que em passen
   If InStr(1, strCadena, ",") > 1 Then
      'Passo la cadena a una matriu
      varA = Split(strCadena, ",")
      'Miro si la matriu es valida
      If UBound(varA) = 2 Then
         'Capturo les dades del parametre
         strVariable = varA(0)
         intBit = Val(varA(1))
         strDescripcio = varA(2)
         bolActiva = False
         'Miro si te una variable relacionada
         If strVariable <> "" Then
            'Busco la variable dintre dels parametres
            Set objVariable = frmPrincipal.BuscarVarParametres(strVariable)
            'Retorno true
            Inicialitza = True
         End If
      End If
   End If

Exit Function
TractaError:
   Inicialitza = False
End Function

Public Property Get Variable() As String
   'Retorno la propietat
   Variable = strVariable
End Property

Public Property Get Bit() As Integer
   'Retorno la propietat
   Bit = intBit
End Property

Public Property Get Descripcio() As String
   'Retorno la propietat
   Descripcio = strDescripcio
End Property

Public Property Get Activa() As Boolean
   'Retorno la propietat
   Activa = bolActiva
End Property

Private Sub objVariable_Actualitza()
Dim dblValor As Double

   On Error GoTo TractaError
   'Desactivo el flag per indicar que l'alarma no esta activa
   bolActiva = False
   'Capturo el valor de la variable
   dblValor = objVariable.Valor
   If dblValor > 0 Then
      'Miro si el bit d'alarma dintre la variable esta activat
      If BitEstatGet(dblValor, intBit - 1) > 0 Then
         'Activo el flag per indicar que l'alarma esta activa
         bolActiva = True
      End If
   End If
   
Exit Sub
TractaError:
   bolActiva = False
End Sub
